﻿Imports System.Net.Sockets
Imports System.Net.Dns
Imports System.Text
Imports System.Threading.Thread


Public Class Adria
    'Dim clientSocket As Socket
    'Dim serverSocket As Socket
    'Dim byteData(1023) As Byte

    'Dim webClient As New System.Net.WebClient

    Dim portnr As Integer = 2000
    Public TcpClient As TcpClient 'public client object
    Public Tcplistener As New TcpListener(portnr)
    Public Stream As NetworkStream 'pubic network stream object

    'Public LocalName As String = String.Empty

    Private Sub Adria_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        close_a()
    End Sub

    Private Sub close_a()
        Dim txt As String = txtIP.Text & "," & txtPort.Text & ","
        My.Computer.FileSystem.WriteAllText("Settings.txt", txt, False)
    End Sub

    Private Sub Adria_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim txt As String
        Try
            txt = My.Computer.FileSystem.ReadAllText("Settings.txt")
        Catch ex As Exception
            txt = txtIP.Text & "," & txtPort.Text & ","
            My.Computer.FileSystem.WriteAllText("Settings.txt", txt, False)
        End Try

        Dim txt1() As String = txt.Split(",")
        txtIP.Text = txt1(0)
        txtPort.Text = txt1(1)
        get_IP()
    End Sub


    Public Sub Connect()
        txtLog.Text += "Connect routine" & vbCrLf

        Try
            txtLog.Text += "Try entered" & vbCrLf
            TcpClient = New TcpClient()
            TcpClient.Connect(txtIP.Text, txtPort.Text)
            If TcpClient.Connected = True Then
                txtLog.Text = "Connected Successfully to " & txtIP.Text
                Timer1.Enabled = True
                Timer1.Start()
            End If
            txtLog.Text += "routine Connect"
            'SendInfo(LocalName)

        Catch ex As SocketException
            'txtRecieve.Text &= "Error: " & ex.Message & Environment.NewLine
            'txtRecieve.Text &= "Failure to Connect to " & IP & " " & Port & Environment.NewLine
            txtLog.Text += "Error: " & ex.Message & Environment.NewLine
            txtLog.Text += "Failure to Connect to "
        End Try

    End Sub
    Public Sub ReadData(ByVal TcpClient As TcpClient)
        Try
            Dim bytes(10024) As Byte
            Dim Data As String
            Dim FinalString As String
            If TcpClient.Connected Then
                Stream = TcpClient.GetStream()
            Else
                Return
            End If


            If Stream.CanRead = True Then
                If Stream.DataAvailable = True Then
                    Data = Stream.Read(bytes, 0, bytes.Length)
                    FinalString = Encoding.ASCII.GetString(bytes)
                    'ListBox1.Items.Add(FinalString)
                    decode_data(FinalString)
                End If
            End If

        Catch ex As SocketException
            'txtRecieve.Text &= "Error: " & ex.Message & Environment.NewLine
            txtLog.Text = "Error: " & ex.Message & Environment.NewLine
        End Try

    End Sub

    Public Sub SendData(ByVal TextToSend1 As String)
        If TcpClient.Connected = True Then
            Try
                Stream = TcpClient.GetStream()

                Dim Bytes As String = TextToSend1
                Dim BytesToWrite As Byte() = Encoding.ASCII.GetBytes(Bytes)

                If Stream.CanWrite = True Then
                    Stream = TcpClient.GetStream
                    txtLog.Text = "You: " & Bytes
                    txtLog.Text = Environment.NewLine
                    Stream.Write(BytesToWrite, 0, BytesToWrite.Length)
                Else
                    txtLog.Text = "***Could Not Send: " & Bytes & " ***"
                    txtLog.Text = Environment.NewLine
                End If
            Catch ex As SocketException
                'txtRecieve.Text &= "Error: " & ex.Message & Environment.NewLine
                txtLog.Text = "Error: " & ex.Message & Environment.NewLine
            End Try
        End If

    End Sub

    Public Sub SendInfo(ByVal Info As String)
        Try
            Stream = TcpClient.GetStream()

            Dim Bytes As String = Info
            Dim BytesToWrite As Byte() = Encoding.ASCII.GetBytes(Bytes)

            If Stream.CanWrite = True Then
                Stream = TcpClient.GetStream
                Stream.Write(BytesToWrite, 0, BytesToWrite.Length)
            End If

        Catch ex As SocketException
            'txtRecieve.Text &= "Error: " & ex.Message & Environment.NewLine
            txtLog.Text = "Error: " & ex.Message & Environment.NewLine
        End Try
    End Sub

    Private Function decode_data(ByVal podatki) As Boolean
        'txtLog.Text += podatki
        Dim darr() As String = podatki.split(",")
        Select Case darr(0)
            Case "SendingData"
               
            Case "Files"
                For x As Integer = 1 To UBound(darr)

                Next
            Case "Arhive"
                For x As Integer = 1 To UBound(darr)

                Next
            
            Case Else
                txtLog.Text = podatki

        End Select
        Return True
    End Function

    
    Private Sub get_IP()
        'Dim myIpadres As System.Net.IPAddress
        'Dim strhost As String
        Dim myWorkstation As String = System.Net.Dns.GetHostName()
        Dim IPAdres As String =
        System.Net.Dns.Resolve(myWorkstation).AddressList(0).ToString
        'TextmyIP.Text = myWorkstation & "=" & IPAdres & vbCrLf
        TextmyIP.Text = IPAdres
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ReadData(TcpClient)

    End Sub

    Private Sub btnListen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnListen.Click
        txtLog.Text += "OK,Listen clicked"
        Connect()
    End Sub



    Private Sub btnGetSensors_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SendData("Sensors")
    End Sub


    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SendData("Satellites")
    End Sub

 

  
    Private Sub Button12_Click(sender As System.Object, e As System.EventArgs) Handles Button12.Click
        Connect()

        Dim data_tosend As String
        data_tosend = TextBox11.Text
        Dim dts As String() = data_tosend.Split(New [Char]() {" "c, CChar(vbLf)})
        Dim data_out As String = ""

        'For a As Integer = 0 To UBound(dts)
        'txtLog.Text += dts(a) & "_"
        'If a <> UBound(dts) Then
        'data_out += dts(a) & "_"
        'End If
        'Next

        'data_out += dts(UBound(dts))

        txtLog.Text = "String : " & data_out

        'data_tosend = data_out


        'If data_tosend <> "$$$" Then
        'data_tosend = data_tosend + vbCrLf
        'End If

        SendData(data_tosend)
    End Sub
   
    Private Sub Sockclose_Click(sender As System.Object, e As System.EventArgs) Handles Sockclose.Click
        TcpClient.Close()
    End Sub

    Private Sub txtLog_DoubleClick(sender As Object, e As System.EventArgs) Handles txtLog.DoubleClick
        txtLog.Clear()
    End Sub


End Class







